import java.util.Arrays;

public class Griddler {

	/**
	 * Solves a puzzle.
	 * 
	 * @param columns
	 *            The definitions for the columns.
	 * @param rows
	 *            The definitions for the rows.
	 * @return The picture.
	 */
	public static int[][] solve(int[][] columns, int[][] rows) {
		int[][] picture = new int[rows.length][columns.length];

		solveRow(picture, columns, rows, 0);

		return picture;
	}

	/**
	 * Updates the row with black (1) and white (0) values according to the
	 * parameters
	 * 
	 * @param pattern
	 *            Indices for the starting points of the black sequences
	 * @param lengths
	 *            The lengths of the black sequences.
	 * @param row
	 *            The array to update.
	 */
	public static void renderPatternInRow(int[] pattern, int[] lengths,
			int[] row) {
	}

	/**
	 * Implements a naive algorithm to solve the puzzle
	 * 
	 * @param picture
	 *            A 2d array that should be filled with the solution
	 * @param columns
	 *            Definitions for the columns
	 * @param rows
	 *            Definitions for the rows
	 * @param current_row
	 *            The current row considered by the algorithm
	 * @return true if this row was successfully updates, false otherwise.
	 */
	public static boolean solveRow(int[][] picture, int[][] columns,
			int[][] rows, int current_row) {
		return false;
	}

	/**
	 * Generates the leftmost position for the given sequences
	 * 
	 * @param lengths
	 *            The sequences
	 * @return An indices array
	 */
	public static int[] firstPattern(int[] lengths) {
		return null;
	}

	/**
	 * Updates the indices of the given pattern according to the algorithm given
	 * in the assignment.
	 * 
	 * @param starts
	 *            An array of start points (indices).
	 * @param lengths
	 *            The lengths of the black sequences
	 * @param width
	 *            The width of the picture
	 * @return true if an update was possible and false if all the sequences are
	 *         in their rightmost position
	 */
	public static boolean nextPattern(int[] starts, int[] lengths, int width) {
		return false;
	}

	/**
	 * Tests whether the first n rows in the picture violates any column
	 * definition
	 * 
	 * @param picture
	 *            The picture obtained thus far
	 * @param columns
	 *            The columns definitions
	 * @param n
	 *            The number of rows to consider
	 * @return true if any column is violated, false otherwise.
	 */
	private static boolean anyColumnViolated(int[][] picture, int[][] columns,
			int n) {
		for (int i = 0; i < columns.length; ++i) {
			if (isColumnViolated(picture, columns[i], n, i))
				return true;
		}

		return false;
	}

	/**
	 * Tests whether a single column's definition is violated by the current
	 * painting of the first n rows in the picture.
	 * 
	 * @param picture
	 *            The picture
	 * @param column
	 *            The definition of this column
	 * @param n
	 *            The number of rows to consider
	 * @param column_index
	 *            The index of the current column
	 * @return true if the designated column is violated, false otherwise.
	 */
	public static boolean isColumnViolated(int[][] picture, int[] column,
			int n, int column_index) {
		return true;
	}
}
